import React, { PropTypes } from 'react';
import { connect } from 'react-redux';

import mount from './redux-actions/mount';
import unmount from './redux-actions/unmount';


export default (Component, { initialComponentState, root }) => {

    const Container = React.createClass({

        displayName: `component(${Component.displayName})`,

        propTypes: {
            initialized: PropTypes.bool.isRequired,
            onMount: PropTypes.func.isRequired,
            onUnmount: PropTypes.func.isRequired,
            // ---
            component: PropTypes.object
        },

        componentDidMount() {
            this.props.onMount();
        },

        componentWillUnmount() {
            this.props.onUnmount();
        },

        render() {
            if (!this.props.initialized) {
                return null;
            }

            const { component } = this.props;

            return (
                <Component
                    component={ component }
                    root={ root } />
            );
        }

    });

    const mapStateToProps = (state) => {
        const component = state.components[root];
        return {
            component,
            initialized: component !== undefined
        };
    };

    const mapDispatchToProps = (dispatch) => {
        return {
            onMount: () => dispatch(mount({ initialComponentState, root })),
            onUnmount: () => dispatch(unmount({ root }))
        };
    };

    return connect(mapStateToProps, mapDispatchToProps)(Container);

};
